﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace csharpdemo
{
    public partial class FrmDesignAndRunModaldialog : Form
    {
        public FrmDesignAndRunModaldialog()
        {
            InitializeComponent();
        }

        private void FrmDesignAndRunModaldialog_Load(object sender, EventArgs e)
        {
            vg1.Design(vg1.DefaultPath + "docset.tbl");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var dlg = vg1.vg.Create(vg1.DefaultPath + "docset.tbl", false, false);
            dlg.ActiveSheet.SetPropertyValue("cursheet", vg1.vg.ActiveSheet);
            dlg.ShowModal();
            dlg.Free();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            vg1.vg.ActiveSheetIndex = 0;
            var dlg = vg1.vg.Create("", false, false);
            dlg.FileName = vg1.vg.FileName;
            dlg.LoadFromBuffer(vg1.vg.SaveToBuffer());
            dlg.ActiveSheet.SetPropertyValue("cursheet", vg1.vg.ActiveSheet);
            dlg.ShowModal();
            dlg.Free();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            var n = vg1.vg.ActiveSheetIndex;
            if (n == 2)
                n = 0;
            else
                n = n + 1;
            vg1.vg.ActiveSheetIndex = n;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            var s = "";
            var i = 0;
            while (i < vg1.vg.SheetCount)
            {
                s = s + vg1.vg.get_Sheets(i).Name + ",";
                i = i + 1;
            };
            MessageBox.Show("There are " + vg1.vg.SheetCount + " sheets, they are : " + s);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            MessageBox.Show("[" + vg1.vg.RangeLeft + "," + vg1.vg.RangeTop + "]-[" + vg1.vg.RangeRight + "," + vg1.vg.RangeBottom + "]");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            vg1.vg.BackColor = 0xC0C0C0;
        }

        private void button7_Click(object sender, EventArgs e)
        {
            vg1.vg.ShowGrid = true;
        }

        private void button8_Click(object sender, EventArgs e)
        {
            vg1.vg.ShowGrid = false;
        }

        private void button9_Click(object sender, EventArgs e)
        {
            vg1.vg.GridSize = 16;
        }

        private void button10_Click(object sender, EventArgs e)
        {
            vg1.vg.GridSize = 32;
        }
    }
}
