unit DrawNewunitByMouse;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, vg_TLB;

type
  TfrmDrawNewunitByMouse = class(TForm)
    vg1: Tvgctrl;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    ToolBar: Tvgctrl;
    Button15: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDrawNewunitByMouse: TfrmDrawNewunitByMouse;

implementation

{$R *.dfm}

procedure TfrmDrawNewunitByMouse.FormShow(Sender: TObject);
begin
  toolbar.Run( 'http://www.visual-graph.com/activex/newunit.xml' );
  vg1.design( '' );
  toolbar.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
end;

procedure TfrmDrawNewunitByMouse.Button1Click(Sender: TObject);
begin
  vg1.vg.NewUnit( nil, 'rect' );
end;

procedure TfrmDrawNewunitByMouse.Button2Click(Sender: TObject);
begin
  vg1.vg.NewUnit( nil, 'line' );
end;

procedure TfrmDrawNewunitByMouse.Button3Click(Sender: TObject);
begin
  vg1.vg.NewUnit( nil, 'circle' );
end;

procedure TfrmDrawNewunitByMouse.Button4Click(Sender: TObject);
begin
  vg1.vg.NewUnit( nil, 'arc' );
end;

procedure TfrmDrawNewunitByMouse.Button5Click(Sender: TObject);
begin
  vg1.vg.NewUnit( nil, 'pie' );
end;

procedure TfrmDrawNewunitByMouse.Button6Click(Sender: TObject);
var
  lb : Ivg;
  bt : IUnit;
begin
  lb := vg1.vg.Create( vg1.DefaultPath + 'controls.tbl', true, false );
  bt := vg1.vg.NewUnit( lb, 'button' );
  if( bt <> nil ) then
    bt.Lib := vg1.vg.FileName;//element link to library
  lb.Free();
end;

procedure TfrmDrawNewunitByMouse.Button7Click(Sender: TObject);
var
  lb : Ivg;
  bt : IUnit;
begin
  lb := vg1.vg.Create( vg1.DefaultPath + 'controls.tbl', true, false );
  bt := vg1.vg.NewUnit( lb, 'listbox' );
  if( bt <> nil ) then
    bt.Lib := vg1.vg.FileName;//element link to library
  lb.Free();
end;

procedure TfrmDrawNewunitByMouse.Button8Click(Sender: TObject);
var
  lb : Ivg;
begin
  lb := vg1.vg.Create( vg1.DefaultPath + 'controls.tbl', true, false );
  vg1.vg.NewUnit( lb, 'vscrollbar' );//this element will embed to the file
  lb.Free();
end;

procedure TfrmDrawNewunitByMouse.Button9Click(Sender: TObject);
var
  lb : Ivg;
begin
  lb := vg1.vg.Create( 'http://www.visual-graph.com/activex/power.xml', true, false );
  vg1.vg.NewUnit( lb, 'TransformerB' );//this element will embed to the file
  lb.Free();
end;

procedure TfrmDrawNewunitByMouse.Button10Click(Sender: TObject);
var
  lb : Ivg;
begin
  lb := vg1.vg.Create( 'http://www.visual-graph.com/activex/power.xml', true, false );
  vg1.vg.NewUnit( lb, 'VGround' );//this element will embed to the file
  lb.Free();
end;

procedure TfrmDrawNewunitByMouse.Button11Click(Sender: TObject);
var
  d : IUnit;
begin
  if( vg1.vg.Selection.UnitCount  = 1 ) then
  begin
    d := vg1.vg.Selection.Units[0];
    vg1.vg.ActiveSheet.DeleteUnit( d );
  end
  else
    ShowMessage( 'Please select a unit first.' );
end;

procedure TfrmDrawNewunitByMouse.Button12Click(Sender: TObject);
var
  i : Integer;
  d : IUnit;
  s : string;
begin
  i := 0;
  s := '';
  while( i < vg1.vg.Selection.UnitCount ) do
  begin
    d := vg1.vg.Selection.Units[i];
    s := s + d.Name + ',';
    i := i + 1;
  end;
  ShowMessage( s );
end;

procedure TfrmDrawNewunitByMouse.Button15Click(Sender: TObject);
begin
  if( vg1.vg.Selection.UnitCount <> 0 ) then
  begin
    vg1.vg.DeleteSelection();
  end
  else
    ShowMessage( 'There are no units selected.' );
end;

procedure TfrmDrawNewunitByMouse.Button13Click(Sender: TObject);
begin
  vg1.vg.Undo();
end;

procedure TfrmDrawNewunitByMouse.Button14Click(Sender: TObject);
begin
  vg1.vg.Redo();
end;

end.
