// DesignModeWithOneActiveX.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "sheet.h"
#include "unit.h"

#include "VC.h"
#include "DesignModeWithOneActiveX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DesignModeWithOneActiveX dialog


DesignModeWithOneActiveX::DesignModeWithOneActiveX(CWnd* pParent /*=NULL*/)
  : CDialog(DesignModeWithOneActiveX::IDD, pParent)
{
  //{{AFX_DATA_INIT(DesignModeWithOneActiveX)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void DesignModeWithOneActiveX::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(DesignModeWithOneActiveX)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  //}}AFX_DATA_MAP
}

BOOL DesignModeWithOneActiveX::PreTranslateMessage( MSG* msg )
{
  return false;
};

BEGIN_MESSAGE_MAP(DesignModeWithOneActiveX, CDialog)
  //{{AFX_MSG_MAP(DesignModeWithOneActiveX)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DesignModeWithOneActiveX message handlers

void DesignModeWithOneActiveX::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 0, 0, cx, cy - 60 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 50, 200, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 200, cy - 50, 200, 20 );
  };  
}

BOOL DesignModeWithOneActiveX::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Run(vg1.GetDefaultPath() + "index.tbl");
  
  return TRUE;
}

void DesignModeWithOneActiveX::OnButton1() 
{
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  VARIANT v = sheet.GetPropertyValue("Inspector");
  CUnit inspectorUnit = (CUnit)v.pdispVal;
  v = inspectorUnit.GetPropertyValue("doc");
  Cvg doc = (Cvg)v.pdispVal;
  CSheet inspector = doc.GetActiveSheet();
  CUnit subwindow7Unit = inspector.UnitByName("subwindow7");
  v = subwindow7Unit.GetPropertyValue("doc");
  doc = (Cvg)v.pdispVal;
  CSheet libview = doc.GetActiveSheet();
  libview.Execute("LoadLibFromFile('" + vg1.GetDefaultPath()+ "controls.tbl')");
}

void DesignModeWithOneActiveX::OnButton2() 
{
  Cvg dlg = vg1.GetVg().Create(vg1.GetDefaultPath() + "files.tbl", false, false);
  if (dlg.ShowModal() == 1)
  {
      VARIANT s = dlg.GetActiveSheet().Execute("return ListBox1.GetItem( ListBox1.ItemIndex )");
      VARIANT t = vg1.GetVg().GetActiveSheet().Execute("return MainForm");
      CSheet mainform = (CSheet)t.pdispVal;
      mainform.Execute("OpenDocument( WebSite + '" + CString( s.bstrVal ) + "', true )");
      SysFreeString( s.bstrVal );
  };
  dlg.Free();
}
