// RunPowerSystemWiringdiagram.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "sheet.h"
#include "unit.h"
#include "VC.h"
#include "RunPowerSystemWiringdiagram.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// RunPowerSystemWiringdiagram dialog


RunPowerSystemWiringdiagram::RunPowerSystemWiringdiagram(CWnd* pParent /*=NULL*/)
  : CDialog(RunPowerSystemWiringdiagram::IDD, pParent)
{
  //{{AFX_DATA_INIT(RunPowerSystemWiringdiagram)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void RunPowerSystemWiringdiagram::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(RunPowerSystemWiringdiagram)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(RunPowerSystemWiringdiagram, CDialog)
  //{{AFX_MSG_MAP(RunPowerSystemWiringdiagram)
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  ON_WM_SIZE()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// RunPowerSystemWiringdiagram message handlers

BOOL RunPowerSystemWiringdiagram::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Run("http://www.visual-graph.com/activex/powersystem.xml");
  return TRUE;
}

void RunPowerSystemWiringdiagram::OnButton1() 
{
  vg1.GetVg().GetActiveSheet().Execute( "i = 0;while i < UnitCount;d = Units[i]; if d.Type = 'DZB' then; b = d.Value; d.Value = true; end if; i = i + 1; wend" );
}

void RunPowerSystemWiringdiagram::OnButton2() 
{
  int i = 0;
  while (i < vg1.GetVg().GetActiveSheet().GetUnitCount())
  {
    CUnit d = vg1.GetVg().GetActiveSheet().GetUnits(i);
    if (d.GetType() == "DZB")
    {
      VARIANT v;
      v.vt = VT_BOOL;
      v.boolVal = false;
      d.SetPropertyValue("Value", v);
    };
    i = i + 1;
  };
}

void RunPowerSystemWiringdiagram::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 0, 0, cx, cy - 60 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 40, 200, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 200, cy - 40, 200, 20 );
    bt = GetDlgItem( IDC_STATIC1 );
    bt->MoveWindow( 400, cy - 40, cx - 400, 20 );
  }
};

BEGIN_EVENTSINK_MAP(RunPowerSystemWiringdiagram, CDialog)
    //{{AFX_EVENTSINK_MAP(RunPowerSystemWiringdiagram)
  ON_EVENT(RunPowerSystemWiringdiagram, IDC_VGCTRL1, 6 /* OnClick */, OnClickVgctrl1, VTS_NONE)
  ON_EVENT(RunPowerSystemWiringdiagram, IDC_VGCTRL1, 12 /* OnMouseMove */, OnMouseMoveVgctrl1, VTS_R8 VTS_R8)
  //}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void RunPowerSystemWiringdiagram::OnClickVgctrl1() 
{
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  CUnit d = sheet.UnitAtCursor( NULL );
    if( d )
        MessageBox("You clicked : " + d.GetName());
}

void RunPowerSystemWiringdiagram::OnMouseMoveVgctrl1(double x, double y) 
{
  char buffer[256];
  sprintf( buffer, "Cursor position : %f,%f", x, y );
  CWnd* label = GetDlgItem( IDC_STATIC1 );
  label->SetWindowText( buffer );
}
