unit DesignAndRunScadapicture;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, vg_TLB;

type
  TfrmDesignAndRunScadapicture = class(TForm)
    vg1: Tvgctrl;
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDesignAndRunScadapicture: TfrmDesignAndRunScadapicture;

implementation

{$R *.dfm}

procedure TfrmDesignAndRunScadapicture.Button2Click(Sender: TObject);
var
  i : Integer;
  g : ISheet;
  s : String;
  d : IUnit;
begin
  i := 0;
  g := vg1.vg.ActiveSheet;
  s := '';
  vg1.vg.BeginUpdate();
  vg1.vg.Selection.Clear();
  while( i < g.UnitCount ) do
  begin
    d := g.Units[ i ];
    s := s + d.Name + ',';
    vg1.vg.Selection.Add( d );
    i := i + 1;
  end;
  vg1.vg.EndUpdate();
  ShowMessage( s );
end;

procedure TfrmDesignAndRunScadapicture.Button1Click(Sender: TObject);
var
  i : Integer;
  g : IGroup;
  s : string;
  d : IUnit;
begin
  i := 0;
  g := vg1.vg.ActiveSheet.GroupByName( 'group1' );
  vg1.vg.BeginUpdate();
  vg1.vg.Selection.Clear();
  s := '';
  while( i < g.UnitCount ) do
  begin
    d := g.Units[ i ];
    s := s + d.Name + ',';
    vg1.vg.Selection.Add( d );
    i := i + 1;
  end;
  vg1.vg.EndUpdate();
  ShowMessage( s );
end;

procedure TfrmDesignAndRunScadapicture.FormShow(Sender: TObject);
begin
  vg1.Run( 'http://www.visual-graph.com/activex/scada.xml' );
  vg1.vg.ShowSelection := true;//enable unit selection at run time...
end;

end.
