unit DesignModeWithMultipleActiveX;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, vg_TLB;

type
  TfrmDesignModeWithMultipleActiveX = class(TForm)
    vg1: Tvgctrl;
    vg2: Tvgctrl;
    vg3: Tvgctrl;
    vg5: Tvgctrl;
    vg6: Tvgctrl;
    vg7: Tvgctrl;
    procedure FormShow(Sender: TObject);
    procedure vg1Scroll(Sender: TObject);
    procedure vg1SelectChange(Sender: TObject);
    procedure vg1MouseMove(ASender: TObject; x, y: Double);
    procedure vg1SheetChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDesignModeWithMultipleActiveX: TfrmDesignModeWithMultipleActiveX;

implementation

{$R *.dfm}

procedure TfrmDesignModeWithMultipleActiveX.FormShow(Sender: TObject);
var
  s : string;
  g : IGroup;
begin
vg1.Design( '' );
s := vg1.DefaultPath;
vg2.Run( s + 'inspector.tbl' );
vg3.Run( s + 'toolbar.tbl' );
vg7.Run( s + 'btnview.tbl' );
vg5.Run( s + 'xruler.tbl' );
vg6.Run( s + 'yruler.tbl' );
vg7.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
vg5.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
vg6.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
vg5.vg.ActiveSheet.Execute( 'ChangeRuler()' );
vg6.vg.ActiveSheet.Execute( 'ChangeRuler()' );
vg3.vg.ActiveSheet.Execute( 'btnPaste.Enable=true' );
vg3.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
vg5.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
vg6.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
vg7.vg.ActiveSheet.SetPropertyValue( 'curSheet', vg1.vg.ActiveSheet );
g := vg1.vg.Selection;
vg2.vg.ActiveSheet.SetPropertyValue( 'selected', g );
vg3.vg.ActiveSheet.Execute( 'OnSelectChange()' );
end;

procedure TfrmDesignModeWithMultipleActiveX.vg1Scroll(Sender: TObject);
begin
  if( vg5.vg <> nil ) then
  begin
    if( vg5.vg.ActiveSheet <> nil ) then
      vg5.vg.ActiveSheet.Execute( 'ChangeRuler()' );
  end;
  if( vg6.vg <> nil ) then
  begin
    if( vg6.vg.ActiveSheet <> nil ) then
      vg6.vg.ActiveSheet.Execute( 'ChangeRuler()' );
  end;
end;

procedure TfrmDesignModeWithMultipleActiveX.vg1SelectChange(
  Sender: TObject);
begin
  vg2.vg.ActiveSheet.SetPropertyValue( 'selected', vg1.vg.Selection );
  vg3.vg.ActiveSheet.Execute( 'OnSelectChange()' );
  vg3.vg.ActiveSheet.Execute( 'btnUndo.Enable=CurSheet.Owner.CanUndo()' );
  vg3.vg.ActiveSheet.Execute( 'btnRedo.Enable=CurSheet.Owner.CanRedo()' );
end;

procedure TfrmDesignModeWithMultipleActiveX.vg1MouseMove(ASender: TObject;
  x, y: Double);
begin
  if( vg5.vg <> nil ) then
  begin
    if( vg5.vg.ActiveSheet <> nil ) then
      vg5.vg.ActiveSheet.Execute( 'mousemove()' );
  end;
  if( vg6.vg <> nil ) then
  begin
    if( vg6.vg.ActiveSheet <> nil ) then
      vg6.vg.ActiveSheet.Execute( 'mousemove()' );
  end;
end;

procedure TfrmDesignModeWithMultipleActiveX.vg1SheetChange( Sender: TObject);
begin
  if( vg3.vg <> nil ) then
  begin
    if( vg3.vg.ActiveSheet <> nil ) then
    begin
      vg3.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
    end;
  end;
  if( vg5.vg <> nil ) then
  begin
    if( vg5.vg.ActiveSheet <> nil ) then
      vg5.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
  end;
  if( vg6.vg <> nil ) then
  begin
    if ( vg6.vg.ActiveSheet <> nil ) then
      vg6.vg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
  end;
  if( vg7.vg <> nil ) then
  begin
    if ( vg7.vg.ActiveSheet <> nil ) then
      vg7.vg.ActiveSheet.SetPropertyValue( 'CurSheet', vg1.vg.ActiveSheet );
  end;
end;

end.
