// DesignAndRunModaldialog.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "sheet.h"
#include "group.h"
#include "unit.h"
#include "VC.h"
#include "DesignAndRunModaldialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DesignAndRunModaldialog dialog


DesignAndRunModaldialog::DesignAndRunModaldialog(CWnd* pParent /*=NULL*/)
  : CDialog(DesignAndRunModaldialog::IDD, pParent)
{
  //{{AFX_DATA_INIT(DesignAndRunModaldialog)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void DesignAndRunModaldialog::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(DesignAndRunModaldialog)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DesignAndRunModaldialog, CDialog)
  //{{AFX_MSG_MAP(DesignAndRunModaldialog)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
  ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
  ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
  ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
  ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
  ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
  ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
  ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DesignAndRunModaldialog message handlers

BOOL DesignAndRunModaldialog::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Design( vg1.GetDefaultPath() + "docset.tbl" );

  return TRUE;
}

void DesignAndRunModaldialog::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);

  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 0, 0, cx, cy - 60 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 50, 120, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 120, cy - 50, 120, 20 );  
    bt = GetDlgItem( IDC_BUTTON3 );
    bt->MoveWindow( 240, cy - 50, 120, 20 );  
    bt = GetDlgItem( IDC_BUTTON4 );
    bt->MoveWindow( 360, cy - 50, 120, 20 );  
    bt = GetDlgItem( IDC_BUTTON5 );
    bt->MoveWindow( 480, cy - 50, 120, 20 );  
    bt = GetDlgItem( IDC_BUTTON6 );
    bt->MoveWindow( 0, cy - 30, 120, 20 );
    bt = GetDlgItem( IDC_BUTTON7 );
    bt->MoveWindow( 120, cy - 30, 120, 20 );  
    bt = GetDlgItem( IDC_BUTTON8 );
    bt->MoveWindow( 240, cy - 30, 120, 20 );  
    bt = GetDlgItem( IDC_BUTTON9 );
    bt->MoveWindow( 360, cy - 30, 120, 20 );  
    bt = GetDlgItem( IDC_BUTTON10 );
    bt->MoveWindow( 480, cy - 30, 120, 20 );  
  };
}

void DesignAndRunModaldialog::OnButton1() 
{
  Cvg dlg = vg1.GetVg().Create( vg1.GetDefaultPath() + "docset.tbl", false, false );
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = sheet.m_lpDispatch;
  dlg.GetActiveSheet().SetPropertyValue( "cursheet", v );
  dlg.ShowModal();
  dlg.Free();
}

void DesignAndRunModaldialog::OnButton2() 
{
  vg1.GetVg().SetActiveSheetIndex( 0 );
  Cvg dlg = vg1.GetVg().Create( "", false, false );
  dlg.SetFileName( vg1.GetVg().GetFileName() );
  dlg.LoadFromBuffer( vg1.GetVg().SaveToBuffer() );
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = sheet.m_lpDispatch;
  dlg.GetActiveSheet().SetPropertyValue( "cursheet", v );
  dlg.ShowModal();
  dlg.Free();
}

void DesignAndRunModaldialog::OnButton3() 
{
  int n = vg1.GetVg().GetActiveSheetIndex();
  if( n == 2 )
    n = 0;
  else
    n = n + 1;
  vg1.GetVg().SetActiveSheetIndex( n );
}

void DesignAndRunModaldialog::OnButton4() 
{
  CString s = "";
  int i = 0;
  while( i < vg1.GetVg().GetSheetCount() )
  {
    s = s + vg1.GetVg().GetSheets(i).GetName() + ",";
    i = i + 1;
  };
  int sc = vg1.GetVg().GetSheetCount();
  char buffer[256];
  sprintf( buffer, "There are %d sheets, they are : ", sc );
  MessageBox( CString( buffer ) + s );
}

void DesignAndRunModaldialog::OnButton5() 
{
  char buffer[256];
  sprintf( buffer, "[%f,%f]-[%f,%f]", vg1.GetVg().GetRangeLeft(), vg1.GetVg().GetRangeTop(), vg1.GetVg().GetRangeRight(), vg1.GetVg().GetRangeBottom() );
  MessageBox( buffer );
}

void DesignAndRunModaldialog::OnButton6() 
{
  vg1.GetVg().SetBackColor( 0xC0C0C0 );
}

void DesignAndRunModaldialog::OnButton7() 
{
  vg1.GetVg().SetShowGrid( true );
}

void DesignAndRunModaldialog::OnButton8() 
{
  vg1.GetVg().SetShowGrid( false );  
}

void DesignAndRunModaldialog::OnButton9() 
{
  vg1.GetVg().SetGridSize( 16 );
}

void DesignAndRunModaldialog::OnButton10() 
{
  vg1.GetVg().SetGridSize( 32 );  
}
