// DesignAndRunScadapicture.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "sheet.h"
#include "group.h"
#include "unit.h"
#include "VC.h"
#include "DesignAndRunScadapicture.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DesignAndRunScadapicture dialog


DesignAndRunScadapicture::DesignAndRunScadapicture(CWnd* pParent /*=NULL*/)
  : CDialog(DesignAndRunScadapicture::IDD, pParent)
{
  //{{AFX_DATA_INIT(DesignAndRunScadapicture)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void DesignAndRunScadapicture::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(DesignAndRunScadapicture)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DesignAndRunScadapicture, CDialog)
  //{{AFX_MSG_MAP(DesignAndRunScadapicture)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DesignAndRunScadapicture message handlers

BOOL DesignAndRunScadapicture::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Run( "http://www.visual-graph.com/activex/scada.xml" );
  vg1.GetVg().SetShowSelection( true );//enable unit selection at run time...
  
  return TRUE;
}

void DesignAndRunScadapicture::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 0, 0, cx, cy - 60 );
    CWnd* bt1 = GetDlgItem( IDC_BUTTON1 );
    bt1->MoveWindow( 0, cy - 50, 200, 20 );
    CWnd* bt2 = GetDlgItem( IDC_BUTTON2 );
    bt2->MoveWindow( 200, cy - 50, 200, 20 );
  };

}

void DesignAndRunScadapicture::OnButton1() 
{
  int i = 0;
  CGroup g = vg1.GetVg().GetActiveSheet().GroupByName( "group1" );
  vg1.GetVg().BeginUpdate();
  vg1.GetVg().GetSelection().Clear();
  CString s = "";
  while( i < g.GetUnitCount() )
  {
    CUnit d = g.GetUnits(i);
    s = s + d.GetName() + ",";
    vg1.GetVg().GetSelection().Add( d );
    i = i + 1;
  };
  vg1.GetVg().EndUpdate();
  MessageBox( s );
}

void DesignAndRunScadapicture::OnButton2() 
{
  int i = 0;
  CSheet g = vg1.GetVg().GetActiveSheet();
  CString s = "";
  vg1.GetVg().BeginUpdate();
  vg1.GetVg().GetSelection().Clear();
  while( i < g.GetUnitCount() )
  {
    CUnit d = g.GetUnits( i );
    s = s + d.GetName() + ",";
    vg1.GetVg().GetSelection().Add( d );
    i = i + 1;
  };
  vg1.GetVg().EndUpdate();
  MessageBox( s );
}
