// DesignModeWithMultipleActiveX.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "sheet.h"
#include "group.h"
#include "unit.h"
#include "VC.h"
#include "DesignModeWithMultipleActiveX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DesignModeWithMultipleActiveX dialog


DesignModeWithMultipleActiveX::DesignModeWithMultipleActiveX(CWnd* pParent /*=NULL*/)
  : CDialog(DesignModeWithMultipleActiveX::IDD, pParent)
{
  //{{AFX_DATA_INIT(DesignModeWithMultipleActiveX)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void DesignModeWithMultipleActiveX::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(DesignModeWithMultipleActiveX)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  DDX_Control(pDX, IDC_VGCTRL2, vg2);
  DDX_Control(pDX, IDC_VGCTRL3, vg3);
  DDX_Control(pDX, IDC_VGCTRL5, vg5);
  DDX_Control(pDX, IDC_VGCTRL6, vg6);
  DDX_Control(pDX, IDC_VGCTRL7, vg7);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DesignModeWithMultipleActiveX, CDialog)
  //{{AFX_MSG_MAP(DesignModeWithMultipleActiveX)
  ON_WM_SIZE()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DesignModeWithMultipleActiveX message handlers

BOOL DesignModeWithMultipleActiveX::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Design("");
  CString s = vg1.GetDefaultPath();
  vg2.Run(s + "inspector.tbl");
  vg3.Run(s + "toolbar.tbl");
  vg7.Run(s + "btnview.tbl");
  vg5.Run(s + "xruler.tbl");
  vg6.Run(s + "yruler.tbl");
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = sheet.m_lpDispatch;
  vg7.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  vg5.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  vg6.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  vg5.GetVg().GetActiveSheet().Execute("ChangeRuler()");
  vg6.GetVg().GetActiveSheet().Execute("ChangeRuler()");
  vg3.GetVg().GetActiveSheet().Execute("btnPaste.Enable=true");
  vg3.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  vg5.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  vg7.GetVg().GetActiveSheet().SetPropertyValue("curSheet", v);
  CGroup g = vg1.GetVg().GetSelection();
  v.pdispVal = g.m_lpDispatch;
  vg2.GetVg().GetActiveSheet().SetPropertyValue("selected", v);
  vg3.GetVg().GetActiveSheet().Execute("OnSelectChange()");  
  return TRUE;
}

BOOL DesignModeWithMultipleActiveX::PreTranslateMessage( MSG* msg )
{
  return false;
};

void DesignModeWithMultipleActiveX::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 220, 80, cx - 200, cy - 80 );
    vg2.MoveWindow( 0, 60, 200, cy - 60 );
    vg3.MoveWindow( 0, 0, cx, 60 );
    vg5.MoveWindow( 220, 60, cx - 220, 20 );
    vg6.MoveWindow( 200, 80, 20, cy - 80 );
    vg7.MoveWindow( 200, 60, 20, 20 );
    OnScrollVgctrl1();
  };
}

BEGIN_EVENTSINK_MAP(DesignModeWithMultipleActiveX, CDialog)
    //{{AFX_EVENTSINK_MAP(DesignModeWithMultipleActiveX)
  ON_EVENT(DesignModeWithMultipleActiveX, IDC_VGCTRL1, 2 /* OnSelectChange */, OnSelectChangeVgctrl1, VTS_NONE)
  ON_EVENT(DesignModeWithMultipleActiveX, IDC_VGCTRL1, 8 /* OnScroll */, OnScrollVgctrl1, VTS_NONE)
  ON_EVENT(DesignModeWithMultipleActiveX, IDC_VGCTRL1, 12 /* OnMouseMove */, OnMouseMoveVgctrl1, VTS_R8 VTS_R8)
  ON_EVENT(DesignModeWithMultipleActiveX, IDC_VGCTRL1, 4 /* OnSheetChange */, OnSheetChangeVgctrl1, VTS_NONE)
  ON_EVENT(DesignModeWithMultipleActiveX, IDC_VGCTRL1, 5 /* OnZoomChange */, OnZoomChangeVgctrl1, VTS_NONE)
  //}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void DesignModeWithMultipleActiveX::OnSelectChangeVgctrl1() 
{
  CGroup g = vg1.GetVg().GetSelection();
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = g.m_lpDispatch;
  vg2.GetVg().GetActiveSheet().SetPropertyValue("selected", v);
  vg3.GetVg().GetActiveSheet().Execute("OnSelectChange()");
  vg3.GetVg().GetActiveSheet().Execute("btnUndo.Enable=CurSheet.Owner.CanUndo()");
  vg3.GetVg().GetActiveSheet().Execute("btnRedo.Enable=CurSheet.Owner.CanRedo()");  
}

void DesignModeWithMultipleActiveX::OnScrollVgctrl1() 
{
  Cvg g5 = vg5.GetVg();
  if ( g5 )
  {
    if (g5.GetActiveSheet())
      g5.GetActiveSheet().Execute("ChangeRuler()");
  }
  Cvg g6 = vg6.GetVg();
  if ( g6 )
  {
    if (g6.GetActiveSheet())
      g6.GetActiveSheet().Execute("ChangeRuler()");
  }  
}

void DesignModeWithMultipleActiveX::OnMouseMoveVgctrl1(double x, double y) 
{
  Cvg g5 = vg5.GetVg();
  if( g5 )
  {
    if ( g5.GetActiveSheet() )
      g5.GetActiveSheet().Execute("mousemove()");
  }
  Cvg g6 = vg6.GetVg();
  if( g6 )
  {
    if( g6.GetActiveSheet() )
      g6.GetActiveSheet().Execute("mousemove()");
  }  
}

void DesignModeWithMultipleActiveX::OnSheetChangeVgctrl1() 
{
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = vg1.GetVg().GetActiveSheet().m_lpDispatch;

  if( vg3.GetVg() )
  {
      if ( vg3.GetVg().GetActiveSheet() )
      {
          vg3.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
      }
  }
  if ( vg5.GetVg() )
  {
      if ( vg5.GetVg().GetActiveSheet() )
          vg5.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  }
  if( vg6.GetVg() )
  {
      if ( vg6.GetVg().GetActiveSheet() )
          vg6.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  }
  if (vg7.GetVg() )
  {
      if (vg7.GetVg().GetActiveSheet() )
          vg7.GetVg().GetActiveSheet().SetPropertyValue("CurSheet", v);
  }
}

void DesignModeWithMultipleActiveX::OnZoomChangeVgctrl1() 
{
  OnScrollVgctrl1();
}
